/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the PlatformCommunicationChannel type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PlatformCommunicationChannel{}

// PlatformCommunicationChannel struct for PlatformCommunicationChannel
type PlatformCommunicationChannel struct {
	Id string `json:"id"`
	Type string `json:"type"`
	ContactId *string `json:"contact_id,omitempty"`
	ProfileName string `json:"profile_name"`
	ProfilePhoto string `json:"profile_photo"`
	PlatformId string `json:"platform_id"`
	Permission ComChannelPermission `json:"permission"`
	Attributes *map[string]string `json:"attributes,omitempty"`
	CreatedAt string `json:"created_at"`
	UpdatedAt string `json:"updated_at"`
}

// NewPlatformCommunicationChannel instantiates a new PlatformCommunicationChannel object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPlatformCommunicationChannel(id string, type_ string, profileName string, profilePhoto string, platformId string, permission ComChannelPermission, createdAt string, updatedAt string) *PlatformCommunicationChannel {
	this := PlatformCommunicationChannel{}
	this.Id = id
	this.Type = type_
	this.ProfileName = profileName
	this.ProfilePhoto = profilePhoto
	this.PlatformId = platformId
	this.Permission = permission
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewPlatformCommunicationChannelWithDefaults instantiates a new PlatformCommunicationChannel object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPlatformCommunicationChannelWithDefaults() *PlatformCommunicationChannel {
	this := PlatformCommunicationChannel{}
	return &this
}

// GetId returns the Id field value
func (o *PlatformCommunicationChannel) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *PlatformCommunicationChannel) SetId(v string) {
	o.Id = v
}

// GetType returns the Type field value
func (o *PlatformCommunicationChannel) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *PlatformCommunicationChannel) SetType(v string) {
	o.Type = v
}

// GetContactId returns the ContactId field value if set, zero value otherwise.
func (o *PlatformCommunicationChannel) GetContactId() string {
	if o == nil || IsNil(o.ContactId) {
		var ret string
		return ret
	}
	return *o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetContactIdOk() (*string, bool) {
	if o == nil || IsNil(o.ContactId) {
		return nil, false
	}
	return o.ContactId, true
}

// HasContactId returns a boolean if a field has been set.
func (o *PlatformCommunicationChannel) HasContactId() bool {
	if o != nil && !IsNil(o.ContactId) {
		return true
	}

	return false
}

// SetContactId gets a reference to the given string and assigns it to the ContactId field.
func (o *PlatformCommunicationChannel) SetContactId(v string) {
	o.ContactId = &v
}

// GetProfileName returns the ProfileName field value
func (o *PlatformCommunicationChannel) GetProfileName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ProfileName
}

// GetProfileNameOk returns a tuple with the ProfileName field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetProfileNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ProfileName, true
}

// SetProfileName sets field value
func (o *PlatformCommunicationChannel) SetProfileName(v string) {
	o.ProfileName = v
}

// GetProfilePhoto returns the ProfilePhoto field value
func (o *PlatformCommunicationChannel) GetProfilePhoto() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ProfilePhoto
}

// GetProfilePhotoOk returns a tuple with the ProfilePhoto field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetProfilePhotoOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ProfilePhoto, true
}

// SetProfilePhoto sets field value
func (o *PlatformCommunicationChannel) SetProfilePhoto(v string) {
	o.ProfilePhoto = v
}

// GetPlatformId returns the PlatformId field value
func (o *PlatformCommunicationChannel) GetPlatformId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PlatformId
}

// GetPlatformIdOk returns a tuple with the PlatformId field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetPlatformIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PlatformId, true
}

// SetPlatformId sets field value
func (o *PlatformCommunicationChannel) SetPlatformId(v string) {
	o.PlatformId = v
}

// GetPermission returns the Permission field value
func (o *PlatformCommunicationChannel) GetPermission() ComChannelPermission {
	if o == nil {
		var ret ComChannelPermission
		return ret
	}

	return o.Permission
}

// GetPermissionOk returns a tuple with the Permission field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetPermissionOk() (*ComChannelPermission, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Permission, true
}

// SetPermission sets field value
func (o *PlatformCommunicationChannel) SetPermission(v ComChannelPermission) {
	o.Permission = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *PlatformCommunicationChannel) GetAttributes() map[string]string {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]string
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetAttributesOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *PlatformCommunicationChannel) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]string and assigns it to the Attributes field.
func (o *PlatformCommunicationChannel) SetAttributes(v map[string]string) {
	o.Attributes = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *PlatformCommunicationChannel) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *PlatformCommunicationChannel) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *PlatformCommunicationChannel) GetUpdatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *PlatformCommunicationChannel) GetUpdatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *PlatformCommunicationChannel) SetUpdatedAt(v string) {
	o.UpdatedAt = v
}

func (o PlatformCommunicationChannel) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PlatformCommunicationChannel) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["type"] = o.Type
	if !IsNil(o.ContactId) {
		toSerialize["contact_id"] = o.ContactId
	}
	toSerialize["profile_name"] = o.ProfileName
	toSerialize["profile_photo"] = o.ProfilePhoto
	toSerialize["platform_id"] = o.PlatformId
	toSerialize["permission"] = o.Permission
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullablePlatformCommunicationChannel struct {
	value *PlatformCommunicationChannel
	isSet bool
}

func (v NullablePlatformCommunicationChannel) Get() *PlatformCommunicationChannel {
	return v.value
}

func (v *NullablePlatformCommunicationChannel) Set(val *PlatformCommunicationChannel) {
	v.value = val
	v.isSet = true
}

func (v NullablePlatformCommunicationChannel) IsSet() bool {
	return v.isSet
}

func (v *NullablePlatformCommunicationChannel) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePlatformCommunicationChannel(val *PlatformCommunicationChannel) *NullablePlatformCommunicationChannel {
	return &NullablePlatformCommunicationChannel{value: val, isSet: true}
}

func (v NullablePlatformCommunicationChannel) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePlatformCommunicationChannel) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


